﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace WebMrbc
{
	public class GrPeach : TargetBoard
	{
		public override FieldDropdown Pins()
		{
			return new FieldDropdown(new[] {
				new [] { "LED1/RED ", "P6_13" },
				new [] { "LED2/GREEN", "P6_14" },
				new [] { "LED3/BLUE", "P6_15" },
				new [] { "LED4/USER", "P6_12" },
				new [] { "D0", "P2_15" },
				new [] { "D1", "P2_14" },
				new [] { "D2", "P4_7" },
				new [] { "D3", "P4_6" },
				new [] { "D4", "P4_5" },
				new [] { "D5", "P4_4" },
				new [] { "D6", "P8_13" },
				new [] { "D7", "P8_11" },
				new [] { "D8", "P8_15" },
				new [] { "D9", "P8_14" },
				new [] { "D10", "P10_13" },
				new [] { "D11", "P10_14" },
				new [] { "D12", "P10_15" },
				new [] { "D13", "P10_12" },
				new [] { "D14", "P1_3" },
				new [] { "D15", "P1_2" },
				new [] { "USER_BUTTON0", "P6_0" },
			});
		}
		public override FieldDropdown AnalogPins()
		{
			return new FieldDropdown(new[] {
				new [] { "A0", "P1_8" },
				new [] { "A1", "P1_9" },
				new [] { "A2", "P1_10" },
				new [] { "A3", "P1_11" },
				new [] { "A4", "P1_13" },
				new [] { "A5", "P1_15" },
			});
		}

		public override FieldDropdown PwmPins()
		{
			return new FieldDropdown(new[] {
				new [] { "PWM0_PIN", "P4_4" },
				new [] { "PWM1_PIN", "P3_2" },
				new [] { "PWM2_PIN", "P4_6" },
				new [] { "PWM3_PIN", "P4_7" },
				new [] { "PWM4_PIN", "P8_14" },
				new [] { "PWM5_PIN", "P8_15" },
				new [] { "PWM6_PIN", "P8_13" },
				new [] { "PWM7_PIN", "P8_11" },
				new [] { "PWM8_PIN", "P8_8" },
				new [] { "PWM9_PIN", "P10_0" },
				new [] { "PWM10_PIN", "P8_12" },
				new [] { "PWM11_PIN", "P8_9" },
				new [] { "PWM12_PIN", "P8_10" },
				new [] { "PWM13_PIN", "P4_5" },
			});
		}

		public override int PinNameToNum(string name)
		{
			switch (name) {
			case "P0_0": return 0;
			case "P0_1": return 1;
			case "P0_2": return 2;
			case "P0_3": return 3;
			case "P0_4": return 4;
			case "P0_5": return 5;
			case "_P0_6": return 6;
			case "_P0_7": return 7;
			case "_P0_8": return 8;
			case "_P0_9": return 9;
			case "_P0_10": return 10;
			case "_P0_11": return 11;
			case "_P0_12": return 12;
			case "_P0_13": return 13;
			case "_P0_14": return 14;
			case "_P0_15": return 15;
			case "P1_0": return 16;
			case "P1_1": return 17;
			case "P1_2": return 18;
			case "P1_3": return 19;
			case "P1_4": return 20;
			case "P1_5": return 21;
			case "P1_6": return 22;
			case "P1_7": return 23;
			case "P1_8": return 24;
			case "P1_9": return 25;
			case "P1_10": return 26;
			case "P1_11": return 27;
			case "P1_12": return 28;
			case "P1_13": return 29;
			case "P1_14": return 30;
			case "P1_15": return 31;
			case "P2_0": return 32;
			case "P2_1": return 33;
			case "P2_2": return 34;
			case "P2_3": return 35;
			case "P2_4": return 36;
			case "P2_5": return 37;
			case "P2_6": return 38;
			case "P2_7": return 39;
			case "P2_8": return 40;
			case "P2_9": return 41;
			case "P2_10": return 42;
			case "P2_11": return 43;
			case "P2_12": return 44;
			case "P2_13": return 45;
			case "P2_14": return 46;
			case "P2_15": return 47;
			case "P3_0": return 48;
			case "P3_1": return 49;
			case "P3_2": return 50;
			case "P3_3": return 51;
			case "P3_4": return 52;
			case "P3_5": return 53;
			case "P3_6": return 54;
			case "P3_7": return 55;
			case "P3_8": return 56;
			case "P3_9": return 57;
			case "P3_10": return 58;
			case "P3_11": return 59;
			case "P3_12": return 60;
			case "P3_13": return 61;
			case "P3_14": return 62;
			case "P3_15": return 63;
			case "P4_0": return 64;
			case "P4_1": return 65;
			case "P4_2": return 66;
			case "P4_3": return 67;
			case "P4_4": return 68;
			case "P4_5": return 69;
			case "P4_6": return 70;
			case "P4_7": return 71;
			case "P4_8": return 72;
			case "P4_9": return 73;
			case "P4_10": return 74;
			case "P4_11": return 75;
			case "P4_12": return 76;
			case "P4_13": return 77;
			case "P4_14": return 78;
			case "P4_15": return 79;
			case "P5_0": return 80;
			case "P5_1": return 81;
			case "P5_2": return 82;
			case "P5_3": return 83;
			case "P5_4": return 84;
			case "P5_5": return 85;
			case "P5_6": return 86;
			case "P5_7": return 87;
			case "P5_8": return 88;
			case "P5_9": return 89;
			case "P5_10": return 90;
			case "P5_11": return 91;
			case "P5_12": return 92;
			case "P5_13": return 93;
			case "P5_14": return 94;
			case "P5_15": return 95;
			case "P6_0": return 96;
			case "P6_1": return 97;
			case "P6_2": return 98;
			case "P6_3": return 99;
			case "P6_4": return 100;
			case "P6_5": return 101;
			case "P6_6": return 102;
			case "P6_7": return 103;
			case "P6_8": return 104;
			case "P6_9": return 105;
			case "P6_10": return 106;
			case "P6_11": return 107;
			case "P6_12": return 108;
			case "P6_13": return 109;
			case "P6_14": return 110;
			case "P6_15": return 111;
			case "P7_0": return 112;
			case "P7_1": return 113;
			case "P7_2": return 114;
			case "P7_3": return 115;
			case "P7_4": return 116;
			case "P7_5": return 117;
			case "P7_6": return 118;
			case "P7_7": return 119;
			case "P7_8": return 120;
			case "P7_9": return 121;
			case "P7_10": return 122;
			case "P7_11": return 123;
			case "P7_12": return 124;
			case "P7_13": return 125;
			case "P7_14": return 126;
			case "P7_15": return 127;
			case "P8_0": return 128;
			case "P8_1": return 129;
			case "P8_2": return 130;
			case "P8_3": return 131;
			case "P8_4": return 132;
			case "P8_5": return 133;
			case "P8_6": return 134;
			case "P8_7": return 135;
			case "P8_8": return 136;
			case "P8_9": return 137;
			case "P8_10": return 138;
			case "P8_11": return 139;
			case "P8_12": return 140;
			case "P8_13": return 141;
			case "P8_14": return 142;
			case "P8_15": return 143;
			case "P9_0": return 144;
			case "P9_1": return 145;
			case "P9_2": return 146;
			case "P9_3": return 147;
			case "P9_4": return 148;
			case "P9_5": return 149;
			case "P9_6": return 150;
			case "P9_7": return 151;
			case "P9_8": return 152;
			case "P9_9": return 153;
			case "P9_10": return 154;
			case "P9_11": return 155;
			case "P9_12": return 156;
			case "P9_13": return 157;
			case "P9_14": return 158;
			case "P9_15": return 159;
			case "P10_0": return 160;
			case "P10_1": return 161;
			case "P10_2": return 162;
			case "P10_3": return 163;
			case "P10_4": return 164;
			case "P10_5": return 165;
			case "P10_6": return 166;
			case "P10_7": return 167;
			case "P10_8": return 168;
			case "P10_9": return 169;
			case "P10_10": return 170;
			case "P10_11": return 171;
			case "P10_12": return 172;
			case "P10_13": return 173;
			case "P10_14": return 174;
			case "P10_15": return 175;
			case "P11_0": return 176;
			case "P11_1": return 177;
			case "P11_2": return 178;
			case "P11_3": return 179;
			case "P11_4": return 180;
			case "P11_5": return 181;
			case "P11_6": return 182;
			case "P11_7": return 183;
			case "P11_8": return 184;
			case "P11_9": return 185;
			case "P11_10": return 186;
			case "P11_11": return 187;
			case "P11_12": return 188;
			case "P11_13": return 189;
			case "P11_14": return 190;
			case "P11_15": return 191;
			default: return -1;
			}
		}

		public override int PinModeNameToNum(string name)
		{
			switch (name) {
			case "INPUT": return 0;
			case "OUTPUT": return 1;
			default: return -1;
			}
		}

		public override int PinValueNameToNum(string name)
		{
			switch (name) {
			case "LOW": return 0;
			case "HIGH": return 1;
			default: return -1;
			}
		}

		public override int AnalogRefModeNameToNum(string name)
		{
			switch (name) {
			case "DEFAULT": return 0;
			case "INTERNAL": return 1;
			case "EXTERNAL": return 2;
			case "RAW12BIT": return 3;
			default: return -1;
			}
		}

		public override FieldDropdown I2CPorts()
		{
			return new FieldDropdown(new[] {
				new[] { "SDA-D14/SCL-D15", "I2C0" },
			});
		}

		public override string I2CPortNameToVariable(string name)
		{
			switch (name) {
			case "I2C0": return "$i2c0";
			case "I2C1": return "$i2c1";
			case "I2C2": return "$i2c2";
			case "I2C3": return "$i2c3";
			default: return name;
			}
		}

		public override int I2CPortNameToNum(string name)
		{
			switch (name) {
			case "I2C0": return 0;
			case "I2C1": return 1;
			case "I2C2": return 2;
			case "I2C3": return 3;
			default: return -1;
			}
		}

		public override FieldDropdown MemFileHandles()
		{
			return new FieldDropdown(new[] {
				new[] { "MemFile0", "MEM_FILE0" },
				new[] { "MemFile1", "MEM_FILE1" }
			});
		}

		public override int MemFileHandlerNameToNum(string name)
		{
			switch (name) {
			case "MEM_FILE0": return 0;
			case "MEM_FILE1": return 1;
			default: return -1;
			}
		}

		public override int MemOpenModeNameToNum(string name)
		{
			switch (name) {
			case "EEP_READ": return 0;
			case "EEP_APPEND": return 1;
			case "EEP_WRITE": return 2;
			default: return -1;
			}
		}

		public override int MemCpModeNameToNum(string name)
		{
			switch (name) {
			case "NO_OVERWRITE": return 0;
			case "OVERWRITE": return 1;
			default: return -1;
			}
		}

		public override FieldDropdown SdFileHandles()
		{
			return new FieldDropdown(new[] {
				new[] { "SdFile0", "SD_FILE0" },
				new[] { "SdFile1", "SD_FILE1" }
			});
		}

		public override int SdFileHandlerNameToNum(string name)
		{
			switch (name) {
			case "SD_FILE0": return 0;
			case "SD_FILE1": return 1;
			default: return -1;
			}
		}

		public override int SdOpenModeNameToNum(string name)
		{
			switch (name) {
			case "READ": return 0;
			case "APPEND": return 1;
			case "NEW_CREATE": return 2;
			default: return -1;
			}
		}

		public override FieldDropdown SerialPorts()
		{
			return new FieldDropdown(new[] {
				new[] { "USB", "SERIAL0" },
				new[] { "TX-0/RX-1", "SERIAL1" },
				new[] { "TX-5/RX-6", "SERIAL2" },
				new[] { "TX-7/RX-8", "SERIAL3" },
				new[] { "TX-12/RX-11", "SERIAL4" },
				new[] { "TX-9(26)/RX-3", "SERIAL5" }
			});
		}

		public override int SerialPortNameToNum(string name)
		{
			switch (name) {
			case "SERIAL0": return 0;
			case "SERIAL1": return 1;
			case "SERIAL2": return 2;
			case "SERIAL3": return 3;
			case "SERIAL4": return 4;
			case "SERIAL5": return 5;
			default: return -1;
			}
		}

		public override string SerialPortNameToVariable(string name)
		{
			switch (name) {
			case "SERIAL0": return "$Serial";
			case "SERIAL1": return "$Serial1";
			case "SERIAL2": return "$Serial2";
			case "SERIAL3": return "$Serial3";
			case "SERIAL4": return "$Serial4";
			case "SERIAL5": return "$Serial5";
			default: return name;
			}
		}
	}
}